//Pistol.cs

//audio
datablock AudioProfile(PistolShotSound)
{
   filename    = "./shoot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(PistolMagout)
{
   filename    = "./magout.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(PistolMagin)
{
   filename    = "./magin.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(PistolSlide)
{
   filename    = "./bolt.wav";
   description = AudioClose3d;
   preload = true;
};
datablock DebrisData(PistolShellDebris)
{
	shapeFile = "./PistolShell.dts";
	lifetime = 2.0;
	minSpinSpeed = -400.0;
	maxSpinSpeed = 200.0;
	elasticity = 0.5;
	friction = 0.2;
	numBounces = 3;
	staticOnMaxBounce = true;
	snapOnMaxBounce = false;
	fade = true;

	gravModifier = 2;
};
AddDamageType("Pistol",   '%1 spammed himself up.',    '%2 spammed up %1.',0.2,1);
datablock ItemData(PistolItem : utaItem)
{
	shapeFile = "./item.dts";
	uiName = "Pistol";
	iconName = "./icon_ui";
	image = PistolImage;
	maxAmmo = 8;
};
datablock ShapeBaseImageData(PistolImage : utaImage)
{
   className = "WeaponImage";
   shapeFile = "./gun.dts";
   armReady = true;
	item = PistolItem;
   ammo = " ";
   projectile = utaProjectile;
   projectileType = Projectile;

   raycastWeaponRange = 60;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = utaProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 8; //Varies based on range
   raycastDirectDamageType = $DamageType::Pistol;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0.001;
   raycastTracerProjectile = "";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 140;
   raycastVerticalImpulse = 100;


   eyeOffset = "0.4 1.2 -0.25";
   offset = "0 0 0.2";


   casing = utaShellDebris;
	shellExitDir        = "1.0 -1.3 1.0";
	shellExitOffset = "-0.1 0 0";
	shellExitVariance   = 15.0;	
	shellVelocity       = 7.0;

	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 0.3;
	stateSequence[0] = "equip";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "preFire";
	stateAllowImageChange[1]         = true;
	
	stateName[19]="preFire";
	stateTimeoutValue[19]=0;
	stateTransitionOnTimeout[19]="preFire2";
	stateScript[19]                  = "onFire";
	stateEjectShell[19]       	  = true;
	stateEmitter[19]					= utaFlashEmitter;
	stateEmitterTime[19]				= 0.05;
	stateEmitterNode[19]				= "muzzleNode";
	stateFire[19]                    = true;
	
	stateName[21]="preFire2";
	stateTransitionOnTimeout[21]="preFire3";
	stateScript[21]				= "onLoadCheck";
	
	stateName[20]="preFire3";
	stateTransitionOnNoAmmo[20]="Fire2";
	stateTransitionOnAmmo[20]="Fire";
	
	stateName[18]="Ready2";
	stateTransitionOnTriggerUp[18]="Ready";

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= PistolShotSound;
	
	stateName[16]                    = "Fire2";
	stateTransitionOnTimeout[16]     = "Delay";
	stateTimeoutValue[16]            = 0.00;
	stateAllowImageChange[16]        = false;
	stateSequence[16]                = "Fire2";
	stateWaitForTimeout[16]			= true;
	stateSound[16]					= PistolShotSound;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.05;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready2";
	stateTransitionOnNoAmmo[5]		= "Reload";

		stateName[6]				= "Reload";
		stateTimeoutValue[6]			= 0.00;
		stateSequence[6]                = "Reload";
		stateScript[6]				= "onReloadStart";
		stateTransitionOnTimeout[6]		= "Reload2";
		stateWaitForTimeout[6]			= true;
		
		stateName[13]				= "Reload2";
		stateTimeoutValue[13]			= 0.06;
		stateTransitionOnTimeout[13]		= "Reload3";
		
		stateName[14]				= "Reload3";
		stateTimeoutValue[14]			= 0.3;
		stateTransitionOnTimeout[14]		= "Reload4";
		stateSound[14]=PistolMagout;
		
		stateName[15]				= "Reload4";
		stateTimeoutValue[15]			= 0.3;
		stateTransitionOnTimeout[15]		= "Reload5";
		stateSound[15]=PistolMagin;
		
		stateName[17]				= "Reload5";
		stateTimeoutValue[17]			= 0.34;
		stateTransitionOnTimeout[17]		= "Wait";
		stateSound[17]=PistolSlide;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.01;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Smoke";
	stateTransitionOnNoAmmo[9]		= "ReloadSmoke";
	
	stateName[10] 				= "Smoke";
	//stateTimeoutValue[10]			= 0.2;
	stateTransitionOnTimeout[10]		= "Ready2";
	//stateTransitionOnTriggerDown[10]	= "Fire";
	
	stateName[11] 				= "ReloadSmoke";
	stateTimeoutValue[11]			= 0.2;
	stateTransitionOnTimeout[11]		= "Reload";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";

};

function PistolImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function PistolImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function PistolImage::onReloadStart(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function PistolImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}

function PistolImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function PistolImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}

//function gunImage::onFire(%this,%obj,%slot)
//{
//	if(%obj.getDamagePercent() < 1.0)
//		%obj.playThread(2, shiftAway);
//	Parent::onFire(%this,%obj,%slot);	
//}
