datablock AudioProfile(RifleShotSound)
{
   filename    = "./shoot.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(RifleMagout)
{
   filename    = "./magout.wav";
   description = AudioClose3d;
   preload = true;
};
datablock AudioProfile(RifleMagin)
{
   filename    = "./magin.wav";
   description = AudioClose3d;
   preload = true;
};
AddDamageType("Rifle",   "%1 self-tacticool'd.",    '%2 showed his tacticool off to %1.',0.2,1);
datablock ItemData(RifleItem : utaItem)
{
	shapeFile = "./item.dts";
	uiName = "Rifle";
	iconName = "./icon_ui";
	image = RifleImage;
	maxAmmo = 48;
};
datablock ShapeBaseImageData(RifleImage : utaImage)
{
   className = "WeaponImage";
   shapeFile = "./gun.dts";
   armReady = true;
   item = RifleItem;
   ammo = " ";
   projectile = utaProjectile;
   projectileType = Projectile;

   eyeOffset = "0.4 1.2 -0.5";

   raycastWeaponRange = 80;
   raycastWeaponTargets = $TypeMasks::FxBrickObjectType |	//Targets the weapon can hit: Raycasting Bricks
   				$TypeMasks::PlayerObjectType |	//AI/Players
   				$TypeMasks::StaticObjectType |	//Static Shapes
   				$TypeMasks::TerrainObjectType |	//Terrain
   				$TypeMasks::VehicleObjectType;	//Vehicles
   raycastWeaponPierceTargets = "";				//Gun cannot pierce
   raycastExplosionProjectile = utaProjectile;
   raycastExplosionSound = ""; //sound played by exploding gunprojectile
   raycastDirectDamage = 6.3; //Varies based on range
   raycastDirectDamageType = $DamageType::Rifle;
   raycastSpreadCount = 1;
   raycastSpreadAmt = 0.001;
   raycastTracerProjectile = "";
   raycastFromMuzzle = 0;
   raycastImpactImpulse = 140;
   raycastVerticalImpulse = 100;

   correctMuzzleVector = true;

	casing = utaShellDebris;
	shellExitDir        = "-1.0 -0.7 0.4";
	shellExitVariance   = 15.0;	
	shellVelocity       = 4.0;
	
	stateName[0]                     = "Activate";
	stateTimeoutValue[0]             = 1;
	stateSequence[0] = "equip";
	stateTransitionOnTimeout[0]       = "LoadCheckA";
	stateSound[0]					= weaponSwitchSound;

	stateName[1]                     = "Ready";
	stateTransitionOnNoAmmo[1]       = "Reload";
	stateTransitionOnTriggerDown[1]  = "Fire";
	stateAllowImageChange[1]         = true;

	stateName[2]                    = "Fire";
	stateTransitionOnTimeout[2]     = "Delay";
	stateTimeoutValue[2]            = 0.00;
	stateFire[2]                    = true;
	stateAllowImageChange[2]        = false;
	stateSequence[2]                = "Fire";
	stateScript[2]                  = "onFire";
	stateEjectShell[2]       	  = true;
	stateEmitter[2]					= utaFlashEmitter;
	stateEmitterTime[2]				= 0.05;
	stateEmitterNode[2]				= "muzzleNode";
	stateWaitForTimeout[2]			= true;
	stateSound[2]					= RifleShotSound;

	stateName[3]			= "Delay";
	stateTransitionOnTimeout[3]     = "FireLoadCheckA";
	stateTimeoutValue[3]            = 0.035;
	
	stateName[4]				= "LoadCheckA";
	stateScript[4]				= "onLoadCheck";
	stateTimeoutValue[4]			= 0.01;
	stateTransitionOnTimeout[4]		= "LoadCheckB";
	
	stateName[5]				= "LoadCheckB";
	stateTransitionOnAmmo[5]		= "Ready";
	stateTransitionOnNoAmmo[5]		= "Reload";

		stateName[6]				= "Reload";
		stateTimeoutValue[6]			= 0.00;
		stateSequence[6]                = "Reload";
		stateScript[6]				= "onReloadStart";
		stateTransitionOnTimeout[6]		= "Reload2";
		stateWaitForTimeout[6]			= true;
		
		stateName[13]				= "Reload2";
		stateTimeoutValue[13]			= 0.5;
		stateTransitionOnTimeout[13]		= "Reload3";
		
		stateName[14]				= "Reload3";
		stateTimeoutValue[14]			= 0.7;
		stateTransitionOnTimeout[14]		= "Reload4";
		stateSound[14]=RifleMagout;
		
		stateName[15]				= "Reload4";
		stateTimeoutValue[15]			= 0.8;
		stateTransitionOnTimeout[15]		= "Wait";
		stateSound[15]=RifleMagin;
	
	stateName[7]				= "Wait";
	stateTimeoutValue[7]			= 0.01;
	stateScript[7]				= "onReloadWait";
	stateTransitionOnTimeout[7]		= "Reloaded";
	
	stateName[8]				= "FireLoadCheckA";
	stateScript[8]				= "onLoadCheck";
	stateTimeoutValue[8]			= 0.01;
	stateTransitionOnTimeout[8]		= "FireLoadCheckB";
	
	stateName[9]				= "FireLoadCheckB";
	stateTransitionOnAmmo[9]		= "Ready";
	stateTransitionOnNoAmmo[9]		= "Reload";
	
	stateName[12]				= "Reloaded";
	stateTimeoutValue[12]			= 0.01;
	stateScript[12]				= "onReloaded";
	stateTransitionOnTimeout[12]		= "Ready";

};

function RifleImage::onFire(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool]--;
	%obj.AmmoSpent[%obj.currTool]++;

			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	Parent::onFire(%this,%obj,%slot);
}

function RifleImage::onReloadWait(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function RifleImage::onReloadStart(%this,%obj,%slot)
{
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function RifleImage::onReloaded(%this,%obj,%slot)
{
	%obj.toolAmmo[%obj.currTool] = %this.item.maxAmmo;
	%obj.AmmoSpent[%obj.currTool] = 0;
	%obj.setImageAmmo(%slot,1);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
	return;
}

function RifleImage::onMount(%this,%obj,%slot)
{
   Parent::onMount(%this,%obj,%slot);
			commandToClient(%obj.client,'bottomPrint',"<just:right><font:arial:64><color:ffffff>" @ %obj.toolAmmo[%obj.currTool] @ "<font:arial:24><color:cccccc> " @ %this.item.maxAmmo @ "", 1,2,3,4); 
}

function RifleImage::onUnMount(%this,%obj,%slot)
{
	%obj.playThread(2, root);
}
